de2023e31376474514f0ace61135f7782a6f2afa
[build-farm.git] / build_test.fns
1 #!/bin/sh -*- mode: shell-script; -*-
2
3 # build_farm -- distributed build/test architecture for samba, rsync, etc
4
5 # Copyright (C) 2001 by Andrew Tridgell <tridge@samba.org>
6 # Copyright (C) 2001 by Andrew Bartlett <abartlet@samba.org>
7 # Copyright (C) 2001, 2003 by Martin Pool <mbp@samba.org>
8
9 # default maximum runtime for any command
10 MAXTIME=25200 # 7 hours
11 SMBD_MAXTIME=18000 # 5 hours for a samba process ..
12 # default maximum memory size (100M) for any command
13 MAXMEM=100000
14 RUN_FROM_BUILD_FARM=yes
15 export RUN_FROM_BUILD_FARM
16 export MAXTIME SMBD_MAXTIME
17
18 deptrees="";
19
20 build_test_fns_id='$Id$'
21
22 copy_dir() {
23         Tsrc=$1
24         Tdst=$2
25         pwd
26         echo rsync -a --delete $Tsrc/ $Tdst
27         rsync -a --delete $Tsrc/ $Tdst || return 1
28         return 0
29 }
30
31 #############################
32 # build a signature of a tree, used to see if we
33 # need to rebuild 
34 #############################
35
36 sum_tree() {
37         sum_tree_test_root=$1
38         sum_tree_tree=$2
39         sum_tree_sum=$3
40         sum_tree_scm=$4
41         find $sum_tree_test_root/$sum_tree_tree -type f -print | grep -v version.h | sort | xargs sum > $sum_tree_sum
42         sum build_test build_test.fns >> $sum_tree_sum
43
44         if [ -f "$host.fns" ]; then
45                 sum $host.fns >> $sum_tree_sum
46         else
47                 sum generic.fns >> $sum_tree_sum
48         fi
49
50         if [ -f "$test_root/$tree.$scm" ]; then
51                 sum "$test_root/$tree.$scm" >> $sum_tree_sum
52         fi
53
54         for d in $deptrees; do
55                 dscm=`choose_scm "$d"`
56                 if [ -f "$test_root/$d.$dscm" ]; then
57                 sum "$test_root/$d.$dscm" >> $sum_tree_sum
58                 fi
59         done
60 }
61
62 #############################
63 # send the logs to the master site
64 #############################
65
66 send_logs() {
67         if [ "$nologreturn" = "yes" ]; then
68                 echo "skipping log transfer"
69         else
70                 log="$1"
71                 err="$2"
72                 shift
73                 shift
74                 chmod 0644 "$log" "$err"
75
76                 # xargs -i is implemented differently or not at all.
77                 # GNU xargs did not implement "-I" until 4.2.9:
78                 xargs --version 2>&1 | grep "^GNU xargs" > /dev/null
79                 status=$?
80                 if [ x"$status" = x"0" ]; then
81                         XARGS_IS_GNU=yes
82                 fi
83
84                 if [ x"$XARGS_IS_GNU" = x"yes" ]; then
85                         XARGS_I="xargs -i"
86                 else
87                         XARGS_I="xargs -I '{}'"
88                 fi
89
90                 find $log -size +40000 | $XARGS_I sh -c 'dd if={} bs=1024 count=20000 of={}.tmp && mv {}.tmp {} &&  echo "\n***LOG TRUNCATED***" >> {}'
91                 find $err -size +40000 | $XARGS_I sh -c 'dd if={} bs=1024 count=20000 of={}.tmp && mv {}.tmp {} &&  echo "\n***LOG TRUNCATED***" >> {}'
92
93                 rsync $* -c -q --password-file=.password -z --timeout=200 \
94                         "$log" "$err" $host@build.samba.org::build_farm_data/
95         fi
96 }
97
98 #############################
99 # send the logs when they haven't changed
100 # the aim is to just update the servers timestamp.
101 # sending with a very large rsync block size does this
102 # with minimal network traffic
103 #############################
104
105 send_logs_skip() {
106         touch "$1" "$2"
107         send_logs "$1" "$2" -B 10000000
108 }
109
110 ############################
111 # fetch the latest copy of the tree
112 ############################
113
114 fetch_tree() {
115         if [ "$norsync" = "yes" ]; then
116                 echo "skipping tree transfer"
117         else
118                 fetchtree=$1
119                 if rsync --exclude=autom4te.cache/ --exclude=.svn/ --exclude=.git/ \
120                         --delete-excluded -q --partial --timeout=200 -ctrlpz --delete --ignore-errors \
121                         samba.org::ftp/unpacked/$fetchtree/ $test_root/$fetchtree; then
122                         echo "transferred $fetchtree OK"
123                 else
124                         echo "transfer of $fetchtree failed code $?"
125                         return 1
126                 fi
127         fi
128         return 0
129 }
130
131 ############################
132 # fetch the latest copy of the rev meta info
133 ############################
134
135 fetch_revinfo() {
136         tree=$1
137         scm=$2
138
139         test -z "$scm" && return 1
140         test x"$scm" = x"unknown" && return 1
141         test x"$scm" = x"cvs" && return 1
142
143         if [ "$norsync" = "yes" ]; then
144                 echo "skipping .revinfo.$scm transfer"
145         else
146                 if [ -r $test_root/$tree.$scm ]; then
147                         [ -f $test_root/$tree.$scm.old ] && rm -f $test_root/$tree.$scm.old
148                         [ -f $test_root/$tree.$scm ] && mv $test_root/$tree.$scm $test_root/$tree.$scm.old
149                 fi
150                 rsync -q --timeout=200 -clz --ignore-errors \
151                         samba.org::ftp/unpacked/$tree/.revinfo.$scm $test_root/$tree.$scm
152         fi
153         if [ -r $test_root/$tree.$scm ]; then
154                 return 0;
155         fi
156         return 1
157 }
158
159 ############################
160 # choose the scm that is used for the given project
161 ############################
162
163 choose_scm() {
164         tree=$1
165
166         case "$tree" in
167                         samba* | rsync | libreplace | talloc | tdb* | ldb | pidl | ccache* | waf*)
168                         echo "git"
169                                 return 0
170                         ;;
171         esac
172
173         echo "svn"
174         return 0
175 }
176
177 locknesting=0
178
179 ############################
180 # grab a lock file. Not atomic, but close :)
181 # tries to cope with NFS
182 ############################
183
184 lock_file() {
185                 if [ -z "$lock_root" ]; then
186                         lock_root=`pwd`;
187                 fi
188
189                 lckf="$lock_root/$1"
190                 machine=`cat "$lckf" 2> /dev/null | cut -d: -f1`
191                 pid=`cat "$lckf" 2> /dev/null | cut -d: -f2`
192
193                 if [ "$pid" = "$$" ]; then
194                         locknesting=`expr $locknesting + 1`
195                         echo "lock nesting now $locknesting"
196                         return 0
197                 fi
198
199                 # We need to assert that the file is > 0 size, as otherwise we never
200                 # recover from disk full situations
201                 if test -f "$lckf" && test -s "$lckf"; then
202                         test x$machine = x$host || {
203                                 echo "lock file $lckf is valid for other machine $machine"
204                                 return 1
205                         }
206
207                         kill -0 $pid && {
208                                 echo "lock file $lckf is valid for process $pid"
209                                 return 1
210                         }
211
212                         echo "stale lock file $lckf for $machine:$pid"
213                         cat "$lckf"
214                         /bin/rm -f "$lckf"
215                 fi
216                 echo "$host:$$" > "$lckf"
217                 return 0
218 }
219
220 ############################
221 # unlock a lock file
222 ############################
223
224 unlock_file() {
225         if [ -z "$lock_root" ]; then
226                 lock_root=`pwd`;
227         fi
228         if [ "$locknesting" != "0" ]; then
229                 locknesting=`expr $locknesting - 1`
230                 echo "lock nesting now $locknesting"
231         else 
232                 lckf="$lock_root/$1"
233                 /bin/rm -f "$lckf"
234         fi
235 }
236
237 ############################
238 # run make, and print trace
239 ############################
240
241 do_make() {
242         # work out correct make command
243         case "$tree" in
244             waf*)
245                 MAKECOMMAND="./waf"
246                 ;;
247             *)
248                 MAKECOMMAND="$MAKE"
249                 if [ x"$MAKECOMMAND" = x ]; then
250                     MAKECOMMAND=make
251                 fi
252                 ;;
253         esac
254
255         MMTIME=$MAXTIME
256         # some trees don't need as much time
257         case "$tree" in
258                 rsync | tdb* | talloc | libreplace | ccache* | waf*)
259                         if [ "$compiler" != "checker" ]; then
260                                 MMTIME=`expr $MMTIME / 5`
261                         fi
262                 ;;
263         esac
264
265         # special build for some trees
266         case "$tree" in
267             waf*)
268                 ./waf distclean && ./waf configure build
269                 ;;
270         esac
271
272
273         for t in $*; do
274                 if [ x"$BUILD_FARM_NUM_JOBS" = x ]; then
275                         echo "$MAKECOMMAND $t"
276                         $builddir/timelimit $MMTIME "$MAKECOMMAND" "$t"
277                         status=$?
278                 else
279                         # we can parallelize everything and all targets
280                         if [ x"$t" = xeverything ] || [ x"$t" = xall]; then
281                                 echo "$MAKECOMMAND" "-j$BUILD_FARM_NUM_JOBS"  "$t"
282                                 $builddir/timelimit $MMTIME "$MAKECOMMAND" "-j$BUILD_FARM_NUM_JOBS"  "$t"
283                                 status=$?
284                         else
285                                 echo "$MAKECOMMAND $t"
286                                 $builddir/timelimit $MMTIME "$MAKECOMMAND" "$t"
287                                 status=$?
288                         fi
289                 fi
290
291                 if [ $status != 0 ]; then
292                         case "$t" in
293                                 test|check|installcheck)
294                                         ;;
295                                 *)
296                                         #run again with V=1, so we see failed commands
297                                         $builddir/timelimit $MMTIME "$MAKECOMMAND" "$t" V=1
298                                         status=$?
299                                         ;;
300                         esac
301                 fi
302
303                 if [ $status != 0 ]; then
304                         return $status;
305                 fi
306
307         done
308
309         return 0
310 }
311
312
313 ############################
314 # do the coverage report
315 ############################
316
317 action_lcovreport() {
318         if [ "$LCOV_REPORT" = "yes" ]; then
319                 case "$tree" in
320                 lorikeet-heimdal*)
321                         lcov --directory $builddir --capture --output-file $builddir/$tree.lcov.info
322                         ;;
323                 samba_4*|tdb*|talloc|ldb|libreplace)
324                         lcov --base-directory $builddir/bin --directory $builddir/bin --capture --output-file $builddir/$tree.lcov.info
325                         ;;
326                 waf)
327                         lcov --base-directory $builddir/demos --directory $builddir/demos --capture --output-file $builddir/$tree.lcov.info
328                         ;;
329                 *)
330                         lcov --base-directory $builddir --directory $builddir --capture --output-file $builddir/$tree.lcov.info
331                         ;;
332                 esac
333                 genhtml -o $builddir/coverage $builddir/$tree.lcov.info
334                 rc=$?
335                 echo "return code: $rc"
336         else
337                 echo "LCOV_REPORT not set and lcovreport asked"
338                 echo "Most probably an error please fix !"
339                 return 1
340         fi
341 }
342
343 action_callcatcherreport() {
344         if [ "$CALLCATCHER_REPORT" = "yes" ]; then
345                 case "$tree" in
346                 tdb*|talloc|ldb)
347                         callanalyse `find $builddir/bin -name \*.so*` $builddir/bin/* > $builddir/coverage/unused-fns.txt
348                         ;;
349                 samba_4*)
350                         callanalyse `find $builddir/bin -name \*.so*` $builddir/bin/* > $builddir/coverage/all-unused-fns.txt 
351                         grep -v -f $srcdir/callcatcher-exceptions.grep $builddir/coverage/all-unused-fns.txt > $builddir/coverage/unused-fns.txt
352                         ;;
353                 esac
354                 rc=$?
355                 echo "return code: $rc"
356         else
357                 echo "CALLCATCHER_REPORT not set and callcatcher asked"
358                 echo "Most probably an error please fix !"
359                 return 1
360         fi
361 }
362
363
364 ############################
365 # configure the tree
366 ############################
367
368 action_configure() {
369         # special handling for some trees
370         case "$tree" in
371             waf*)
372                 $builddir/timelimit $MAXTIME ./waf configure
373                 cstatus=$?
374                 echo "CONFIGURE STATUS: $cstatus"
375                 return $cstatus
376                 ;;
377         esac
378
379         if [ ! -x $srcdir/configure -a -r $srcdir/Makefile.PL ]; then
380                 perl $srcdir/Makefile.PL PREFIX="$prefix"
381                 cstatus=$?
382                 echo "CONFIGURE STATUS: $cstatus"
383                 return $cstatus;
384         fi
385
386         if [ ! -x $srcdir/configure ]; then
387                 ls -l $srcdir/configure
388                 echo "$srcdir/configure is missing"
389                 cstatus=255
390                 echo "CONFIGURE STATUS: $cstatus"
391                 return $cstatus;
392         fi
393
394         echo "CFLAGS=$CFLAGS"
395         echo configure options: $config_and_prefix
396         echo CC="$CCACHE $compiler" $srcdir/configure $config_and_prefix
397
398         CC="$CCACHE $compiler"
399         export CC
400         $builddir/timelimit $MAXTIME $srcdir/configure $config_and_prefix
401         cstatus=$?
402
403         if [ x"$cstatus" != x"0" ]; then
404                 if [ -f config.log ]; then
405                         echo "contents of config.log:"
406                         cat config.log
407                 fi
408
409                 # Waf style
410                 if [ -f bin/config.log ]; then
411                         echo "contents of config.log:"
412                         cat bin/config.log
413                 fi
414         fi
415         echo "CONFIGURE STATUS: $cstatus"
416         return $cstatus
417 }
418
419 ############################
420 # show the configure log
421 ############################
422
423 action_config_log() {
424
425         log_files="config.log bin/config.log"
426         for f in $log_files; do
427                 if [ -f $f ]; then
428                         echo "contents of config.log:"
429                         cat $f
430                         return 0
431                 fi
432         done
433         return 0
434 }
435
436 ############################
437 # show the config.h
438 ############################
439
440 action_config_header() {
441         hdr_files="config.h include/config.h include/autoconf/config.h bin/default/config.h bin/default/include/config.h bin/default/source3/include/config.h"
442         for h in $hdr_files; do
443                 if [ -f $h ]; then
444                         echo "contents of $h:"
445                         cat $h
446                         return 0
447                 fi
448         done
449
450         return 0
451 }
452
453
454
455 ############################
456 # build the tree
457 ############################
458 action_build() {
459         case "$tree" in
460         samba_4*)
461                 do_make everything
462                 bstatus=$?
463                 ;;
464         samba_3*)
465                 do_make everything torture
466                 bstatus=$?
467                 ;;
468         waf*)
469                 do_make build
470                 bstatus=$?
471                 ;;
472         *)
473                 do_make all
474                 bstatus=$?
475                 ;;
476         esac
477
478         echo "BUILD STATUS: $bstatus"
479
480         return $bstatus
481 }
482
483 ############################
484 # show static analysis results
485 ############################
486
487 action_cc_checker() {
488
489         # default to passing the cc_checker
490         cccstatus=0
491
492         if [ -f ibm_checker.out ]; then
493                 cat ibm_checker.out
494                 cccstatus=`cat ibm_checker.out | grep '^\-\- ' | wc -l`
495         fi
496
497         echo "CC_CHECKER STATUS: $cccstatus"
498         return $cccstatus;      
499 }
500
501 ############################
502 # install the tree
503 ############################
504
505 action_install() {
506         if [ -d $prefix ]; then
507                 if [ "$noclean" != "yes" ]; then
508                         rm -rf $prefix
509                 fi
510         fi
511
512         do_make install
513         istatus=$?
514         echo "INSTALL STATUS: $istatus"
515         return $istatus;
516 }
517
518 ############################
519 # test the tree
520 action_test_samba() {
521         do_make test
522         totalstatus=$?
523
524         # if we produced a test summary then show it
525         [ -f st/summary ] && {
526                 echo "TEST SUMMARY"
527                 cat st/summary
528         }
529
530         return "$totalstatus"
531 }
532
533 action_test_generic() {
534         CC="$compiler"
535         export CC
536         do_make installcheck
537         totalstatus=$?
538         echo "TEST STATUS: $totalstatus"
539         return "$totalstatus"
540 }
541
542 action_test_lorikeet_heimdal() {
543         CC="$compiler"
544         export CC
545         SOCKET_WRAPPER_DIR=`pwd`/sw
546         mkdir $SOCKET_WRAPPER_DIR
547         export SOCKET_WRAPPER_DIR
548         do_make check
549         totalstatus=$?
550         SOCKET_WRAPPER_DIR=
551         export SOCKET_WRAPPER_DIR
552         echo "TEST STATUS: $totalstatus"
553         return "$totalstatus"
554 }
555
556
557 #############################
558 # attempt some basic tests of functionaility
559 # starting as basic as possible, and getting incresingly complex
560 #############################
561
562 action_test() {
563         # Samba needs crufty code of its own for backward
564         # compatiblity.  I think a better way to do this in the future
565         # is to just call 'make installcheck'.
566         case "$tree" in
567         samba*|smb-build|pidl)
568                 action_test_samba
569                 ;;
570         lorikeet-heimdal*)
571                 action_test_lorikeet_heimdal
572                 ;;
573         *)
574                 action_test_generic
575                 ;;
576         esac
577 }
578
579 #############################
580 # Do nothing (needed if we have nothing to do for extra_actions)
581 #############################
582
583 action_none() {
584     return 0;
585 }
586
587 ###########################
588 # do a test build of a particular tree
589 # This is the master function called by generic.fns or
590 # host.fns
591 ###########################
592
593 test_tree() {
594         tree=$1
595         source=$2
596         compiler="$3"
597         shift
598         shift
599         shift
600         echo "Starting to deal with tree $tree with compiler $compiler"
601         if [ "$compiler" = "gcc" ] && [ "$tree" != "ccache" ] && [ "$tree" != "ccache-maint" ] && ccache -V > /dev/null 2>/dev/null; then
602                 CCACHE="ccache"
603                 export CCACHE
604         else
605                 CCACHE=""
606         fi
607
608         # limit our resource usage
609         ulimit -t $MAXTIME 2> /dev/null
610
611         # max mem size 100M
612         ulimit -m $MAXMEM 2> /dev/null
613
614         # max file size 100M
615         # darn, this affects sparse files too! disable it
616         # ulimit -f 100000 2> /dev/null
617
618         # try and limit the number of open files to 500, up from 250. That means we'll discover
619         # fd leaks faster while allowing our very complex make test to run
620         ulimit -n 500 2> /dev/null
621
622         # Keep stuff private
623         umask 077
624
625         if [ -z "$test_root" ]; then
626                 test_root=`pwd`
627         fi
628
629         log="build.$tree.$host.$compiler.log"
630         err="build.$tree.$host.$compiler.err"
631         sum="build.$tree.$host.$compiler.sum"
632         lck="build.$tree.lck"
633                 srcdir="$test_root/$tree/$source"
634
635         lock_file "$lck" || {
636                 return
637         }
638
639         # work out what other trees this package depends on
640         deptrees=""
641         case "$tree" in
642                 samba-gtk)
643                 deptrees="samba_4_0_test"
644                 ;;
645         esac
646
647         scm=`choose_scm "$tree"`
648
649         # pull the entries, if any
650         # Remove old .svn or .git files
651         # Move the current .svn org .git to .svn.old or
652         # .git.old then fetch the new from rsync
653         if fetch_revinfo "$tree" "$scm"; then
654                 for d in $deptrees; do
655                         # If there is dependency substree(s) we add info
656                         # from the dependency tree so that we
657                         # can rebuild in case one of them has changed
658                         dscm=`choose_scm "$d"`
659                         if [ -f "$test_root/$d.$dscm" ]; then
660                                 if [ "$d" != "$tree" ]; then
661                                         cat "$test_root/$d.$dscm" >> $test_root/$tree.$scm
662                                 fi
663                         fi
664                 done
665                 [ -f $test_root/$tree.$compiler.$scm.old ] && rm -f $test_root/$tree.$compiler.$scm.old
666                 [ -f $test_root/$tree.$compiler.$scm ] && mv $test_root/$tree.$compiler.$scm $test_root/$tree.$compiler.$scm.old
667                 [ -f $test_root/$tree.$scm ] && cp $test_root/$tree.$scm $test_root/$tree.$compiler.$scm
668
669                 if [ -f $test_root/$tree.$compiler.$scm.old ] && \
670                                 cmp $test_root/$tree.$compiler.$scm $test_root/$tree.$compiler.$scm.old > /dev/null; then
671
672                         echo "skip: $tree.$compiler nothing changed in $scm"
673                         cd $test_root
674                         send_logs_skip "$log" "$err"
675                         unlock_file "$lck"
676                         return
677                 fi
678         fi
679
680         # pull the tree
681         fetch_tree "$tree" || {
682                 cd $test_root
683                 unlock_file "$lck"
684                 return
685         }
686
687         # check for essential files
688         case "$tree" in
689             pidl)
690                 # no generated files
691                 ;;
692             waf*)
693                 if [ ! -x $srcdir/waf ]; then
694                     echo "skip: $tree.$compiler waf not present, try again next time!"
695                     cd $test_root
696                     unlock_file "$lck"
697                     return
698                 fi
699                 ;;
700             *)
701                 if [ ! -x $srcdir/configure ]; then
702                     echo "skip: $tree.$compiler configure not present, try again next time!"
703                     cd $test_root
704                     unlock_file "$lck"
705                     return
706                 fi
707                 ;;
708         esac
709
710         echo "Starting build of $tree.$compiler in process $$ at `date`"
711
712
713         # Parameters for the build depending on the tree
714         case "$tree" in
715                 *)
716                         builddir=$srcdir
717                         export builddir
718                         ;;
719         esac
720
721         #Fix the user
722         if [ ! x$USER = x"" ]; then
723                 whoami=$USER
724         else 
725                 if [ ! x$LOGNAME = x"" ]; then
726                         whoami=$LOGNAME
727                 else
728                         whoami=build
729                 fi
730         fi
731
732         # build the timelimit utility
733         echo "Building timelimit"
734         mkdir -p $builddir
735         echo $compiler $TIMELIMIT_FLAGS -o $builddir/timelimit $test_root/timelimit.c
736         $compiler $TIMELIMIT_FLAGS -o $builddir/timelimit $test_root/timelimit.c || exit 1
737
738         # build the killbysubdir utility
739         echo "Building killbysubdir"
740         echo $compiler -o $builddir/killbysubdir $test_root/killbysubdir.c
741         $compiler -o $builddir/killbysubdir $test_root/killbysubdir.c
742
743         prefix="$test_root/prefix/$tree.$compiler"
744         mkdir -p "$prefix"
745
746         # This can be defined in <host>.fns files
747         sw_config=$config
748
749         case "$tree" in
750         lorikeet-heimdal)
751                 sw_config="$config --enable-socket-wrapper"
752                 ;;
753         samba_4*)
754                 sw_config="$config --enable-selftest"
755                 ;;
756         samba_3*)
757                 sw_config="$config --enable-socket-wrapper"
758                 sw_config="$sw_config --enable-nss-wrapper"
759                 ;;
760         samba-gtk)
761                 PKG_CONFIG_PATH="$test_root/prefix/samba_4_0_test.$compiler/lib/pkgconfig"
762                 export PKG_CONFIG_PATH
763                 ;;
764         *)
765                 testsuite=testsuite
766                 ;;
767         esac
768
769         if [ "$LCOV_REPORT" = "yes" ]; then
770                 PRE_GCOV_CFLAGS=$CFLAGS
771                 PRE_GCOV_LDFLAGS=$LDFLAGS
772                 GCOV_FLAGS="--coverage"
773                 CFLAGS="$CFLAGS $GCOV_FLAGS" 
774                 LDFLAGS="$LDFLAGS $GCOV_FLAGS" 
775                 export CFLAGS LDFLAGS
776         fi
777
778         config_and_prefix="$sw_config --prefix=$prefix"
779
780         # see if we need to rebuild
781         sum_tree $test_root $tree $sum $scm
782         echo "CFLAGS=$CFLAGS $config_and_prefix" >> $sum
783
784         if [ -f "$sum.old" ] && cmp "$sum" "$sum.old" > /dev/null; then
785                 echo "skip: $tree.$compiler nothing changed"
786                 cd $test_root
787                 send_logs_skip "$log" "$err"
788                 unlock_file "$lck"
789                 echo "Ending build of $tree.$compiler in process $$ at `date`"
790                 if [ "$LCOV_REPORT" = "yes" ]; then
791                     CFLAGS=$PRE_GCOV_CFLAGS
792                     LDFLAGS=$PRE_GCOV_LDFLAGS
793                     export CFLAGS LDFLAGS
794                 fi
795                 return
796         fi
797
798         # we do need to rebuild - save the old sum
799         [ -f $sum.old ] && /bin/rm -f $sum.old
800         mv $sum $sum.old
801
802         #Action == what to do ie. configure config_log ...
803         actions="$*"
804         extra_actions="$EXTRA_ACTIONS"
805
806         if [ "$actions" = "" ]; then
807                 actions="configure config_log config_header build install test"
808         fi
809
810         if [ "$extra_actions" = "" ]; then
811                 extra_actions="none"
812         fi
813
814         # start the build
815         (
816         {
817                 # we all want to be able to read the output...
818                 LANG=C
819                 export LANG
820
821                 uname -a
822
823                 echo ""
824                 echo "build_test                  : $build_test_id"
825                 echo "build_test.fns      : $build_test_fns_id"
826                 echo "local settings file : $build_test_settings_local_file"
827                 echo "local functions file: $build_test_fns_local_file"
828                 echo "used .fns file      : $build_test_used_fns_file"
829                 echo ""
830
831                 # we need to be able to see if a build farm machine is accumulating
832                 # stuck processes. We do this in two ways, as we don't know what style
833                 # of ps it will have
834                 ps xfuw 2> /dev/null
835                 ps -fu $USER 2> /dev/null
836
837                 echo "building $tree with CC=$compiler on $host at "`date`
838                 echo "builddir=$builddir"
839                 echo "prefix=$prefix"
840
841                 echo "Showing limits"
842                 ulimit -a 2> /dev/null
843
844                 # the following is for non-samba builds only
845                 if [ "$scm" = "svn" -a -r $test_root/$tree.svn ]; then
846                         h_rev=`grep 'Revision: ' $test_root/$tree.svn | cut -d ':' -f2 | cut -d ' ' -f2 | sed 1q`
847                         if [ -n "$h_rev" ]; then
848                                 echo "HIGHEST SVN REVISION: $h_rev"
849                         fi
850                         rev=`grep 'Last Changed Rev: ' $test_root/$tree.svn | cut -d ':' -f2 | cut -d ' ' -f2 | sed 1q`
851                         if [ -n "$rev" ]; then
852                         echo "BUILD REVISION: $rev"
853                         fi
854                 elif [ "$scm" = "git" -a -r $test_root/$tree.git ]; then
855                         csha1=`cat $test_root/$tree.git |head -3 | tail -1`
856                         if [ -n "$csha1" ]; then
857                                 echo "BUILD COMMIT REVISION: $csha1"
858                         fi
859                         cdate=`cat $test_root/$tree.git |head -4 | tail -1`
860                         if [ -n "$cdate" ]; then
861                                 echo "BUILD COMMIT DATE: $cdate"
862                         fi
863                         ctime=`cat $test_root/$tree.git |head -2 | tail -1`
864                         if [ -n "$ctime" ]; then
865                                 echo "BUILD COMMIT TIME: $ctime"
866                   fi
867                 fi
868
869                 if [ -x $builddir/killbysubdir ]; then
870                         echo "$builddir/killbysubdir $builddir in `pwd`"
871                         $builddir/killbysubdir $builddir
872                 fi
873
874                 for action in $actions; do
875
876                         echo Running action $action
877
878                         date
879
880                         cd $builddir || exit 1
881                         export srcdir
882                         df .
883                         mount
884                         vmstat
885
886                         if [ "x$PREHOOKS" != "x" ]; then
887                                 for hooks in $PREHOOKS; do
888                                         if [ "x$hooks" = "x$action" ]; then
889                                                 ( prehook_$action )
890                                         fi
891                                 done
892                         fi
893
894                         ( action_$action )
895                         action_status=$?
896
897                         if [ "x$POSTHOOKS" != "x" ]; then
898                                 for hooks in $POSTHOOKS; do
899                                         if [ "x$hooks" = "x$action" ]; then
900                                                 ( posthook_$action )
901                                         fi
902                                 done
903                         fi
904
905                         df .
906
907                         if [ $action_status != 0 ]; then
908                                 echo "ACTION FAILED: $action";
909                                 echo " return code $action_status $action";
910                         else
911                                 echo "ACTION PASSED: $action";
912                         fi
913
914                         if [ $action_status != 0 ]; then 
915                                 break;
916                         fi
917                 done
918
919                 for action in $extra_actions; do
920                         if [ "x$action" = "x" ]; then
921                               break;
922                         fi
923
924                         echo Running action $action
925
926                         date
927
928                         cd $builddir || exit 1
929                         export srcdir
930                         df .
931                         mount
932                         vmstat
933
934                         if [ "x$PREHOOKS" != "x" ]; then
935                                 for hooks in $PREHOOKS; do
936                                         if [ "x$hooks" = "x$action" ]; then
937                                                 ( prehook_$action )
938                                         fi
939                                 done
940                         fi
941
942                         ( action_$action )
943                         action_status=$?
944
945                         if [ "x$POSTHOOKS" != "x" ]; then
946                                 for hooks in $POSTHOOKS; do
947                                         if [ "x$hooks" = "x$action" ]; then
948                                                 ( posthook_$action )
949                                         fi
950                                 done
951                         fi
952
953                         df .
954
955                         if [ $action_status != 0 ]; then
956                                 echo "ACTION FAILED: $action";
957                                 echo " return code $action_status $action";
958                         else
959                                 echo "ACTION PASSED: $action";
960                         fi
961
962                         if [ $action_status != 0 ]; then 
963                                 break;
964                         fi
965                 done
966
967
968                 if [ "$noclean" = "yes" ]; then
969                         echo cleanup skipped!
970                 else
971                         echo cleaning up
972                         do_make clean
973                 fi
974                 date
975         } 3>&2 2>&1 1>&3 | tee "$err"
976         ) > "$log" 2>&1
977         # be aware the above channel swap may sometimes result in unordered
978         # stdout/stderr merge
979
980         if [ "$LCOV_REPORT" = "yes" ]; then
981                 chmod u=rwX,g=rX,o=rX -R $builddir/coverage
982                 rsync -rct -q --password-file=.password -z --timeout=200 \
983                         $builddir/coverage/ $host@build.samba.org::lcov_data/$host/$tree/
984                 CFLAGS=$PRE_GCOV_CFLAGS
985                 LDFLAGS=$PRE_GCOV_LDFLAGS
986                 export CFLAGS LDFLAGS
987         fi
988
989         cd $test_root
990
991         /bin/rm -rf $prefix
992         # send the logs to the master site
993         send_logs "$log" "$err"
994
995         # cleanup
996         echo "Ending build of $tree.$compiler in process $$ at `date`"
997         unlock_file "$lck"
998 }
999
1000 #########################################################
1001 # if you want to build only one project at a time
1002 # add 'global_lock' after 'per_run_hook' and
1003 # 'global_unlock' to the end of the file
1004 #########################################################
1005
1006 global_lock() {
1007         lock_file "global.lck" || {
1008                 exit 0
1009         }
1010 }
1011
1012 global_unlock() {
1013         unlock_file "global.lck"
1014 }
1015
1016 delete_old_tree() {
1017         otree=$1
1018         test -z "$otree" && return 0;
1019
1020         rm -rf $otree
1021         rm -rf $otree.svn
1022         rm -rf $otree.*.svn
1023         rm -rf $otree.git
1024         rm -rf $otree.*.git
1025         rm -rf build.$otree.*
1026 }
1027
1028 # this is a special fn that allows us to add a "special" hook to the build
1029 # farm that we want to do to the build farm. never leave it empty. instead,
1030 # use ":" as the fn body.
1031 per_run_hook() {
1032         # kill old processes on systems with a known problem
1033         case $host in
1034         nohost)
1035                 echo "just a placeholder";
1036                 ;;
1037         deckchair)
1038                 rm -f deckchair.fns
1039                 ;;
1040         esac
1041
1042         # trim the log if too large
1043         if [ "`wc -c < build.log`" -gt 2000000 ]; then
1044         rm -f build.log
1045         fi
1046
1047         old_trees="web popt distcc samba-gtk smb-build lorikeet-heimdal samba_3_2"
1048         old_trees="$old_tree samba_3_2_test samba4 samba_4_0_waf samba_4_0_waf.metze"
1049         old_trees="$old_tree samba_3_X_test samba_3_X_devel samba_3_X_devel samba_3_waf samba_3_master"
1050         for d in $old_trees; do
1051                 delete_old_tree $d
1052         done
1053 }
1054
1055
1056 ######################################################
1057 # main code that is run on each call to the build code
1058 ######################################################
1059 rsync --timeout=200 -q -az build.samba.org::build_farm/*.c .
1060
1061
1062 # build.log can grow to an excessive size, trim it beyond 50M
1063 if [ -f build.log ]; then
1064         find build.log -size +100000 -exec /bin/rm '{}' \;
1065 fi